package dynamiclistmodel;


//Imports
import java.awt.*;
import javax.swing.*;

class Main extends 	JFrame {
 // Instance attributes used in this example
 private	JList<String>			listbox;
 private	CustomListModel	listData;
 private	JScrollPane 	scrollPane;
 
 
 // Constructor of main frame
 public Main()	{
	// Set the frame characteristics
	setTitle( "Custom Data Model JList" );
	setBackground( Color.gray );
	
	// Create the data model for this example
	listData = new CustomListModel();
	
	// Create a new listbox control
	listbox = new JList<String>( listData );
    	listbox.setPrototypeCellValue("MMMMMMMMM");
	// Add the listbox to a scrolling pane
	scrollPane = new JScrollPane();
	scrollPane.getViewport().add( listbox );
	add( scrollPane, BorderLayout.CENTER );
 }
 
 // Main entry point for this example
 public static void main( String args[] )	{
	// Create an instance of the test application
	final Main mainFrame = new Main();
	mainFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	Runnable showFrame = new Runnable() {
		public void run() {
		    mainFrame.pack();
		    mainFrame.setVisible(true);
		}
	};
	SwingUtilities.invokeLater(showFrame);
 }

 class CustomListModel extends AbstractListModel<String> {
	// Return the size of the list
	public int getSize() {
	    return 300;
	}
	
	// Return an element from the list
	public String getElementAt( int index )	{
	    System.out.println("CustomListModel.getElementAt(" + index + ")");
	    return "Item " + index;
	}
 }
}
